@rem =========================================================================
@rem  Copyright (C) VMware, Inc. 1986-2011.  All Rights Reserved..
@rem 
@rem  Name - upgradeImage
@rem 
@rem  Purpose - 
@rem	upgrades to the latest version of the image
@rem 
@rem $Id: upgradeImage.bat,v 1.1 2008-02-15 02:03:11 normg Exp $
@rem 
@rem =========================================================================

@setlocal

@if not "%GEMSTONE%" == "" goto gemstoneok
  @echo ERROR: GemStone scripts require a GEMSTONE environment variable.
  @echo        Please set it to the directory containing the version of GemStone 
  @echo        that you are upgrading to.
  @goto failed
:gemstoneok

@if exist %GEMSTONE%\version.txt goto versionfileexists
  @echo WARNING: The GEMSTONE envvar is set to '%GEMSTONE%'.
  @echo  This directory should contain a 'version.txt' file but does not.
  @echo.
  @echo If you want to stop upgradeImage and reset GEMSTONE then
  @echo stop now with Ctrl+C.
  @pause
  @goto donewithverfilecheck
:versionfileexists

@echo.
@echo The following lines show the contents of '%GEMSTONE%\version.txt'.
@type %GEMSTONE%\version.txt
@echo.
@echo The version shown should be a 6.6 or later version. If it is not then
@echo stop now with Ctrl+C and restart with GEMSTONE properly set.
@if "%2" == "all" goto nopause
@pause
:nopause  

:donewithverfilecheck

@set upgradeDir=%GEMSTONE%\upgrade
@if exist %upgradeDir%\upgradeImage.topaz goto upgradefileok
  @echo ERROR: The directory '%upgradeDir%' does not contain 'upgradeImage.topaz'
  @echo        Make sure GEMSTONE is set to your 6.6.x GemStone installation.
  @goto failed
:upgradefileok
  
@if not "%upgradeLogDir%" == "" goto upgradelogok
  @echo ERROR: The environment variable upgradeLogDir has not been set.
  @goto failed
:upgradelogok

@set stoneName=%1

@if not "%stoneName%" == "" goto stonenameok
  @echo ERROR: stone name must be provided on the command line.
  @echo usage: upgradeImage stonename
  @goto failed
:stonenameok

@echo.
@echo This script does the second part of repository conversion.
@echo.
@echo Note: All user defined changes and additions to kernel classes
@echo will be removed. It is therefore advised that all such changes
@echo be filed out before conversion and filed back in. Layered products,
@echo such as GemConnect, which change the kernel classes will also lose 
@echo the changes. All such products should be reinstalled.
@echo.
@echo Stone name is %stoneName%.
@echo.

@pause

@echo.
@echo Starting upgrade to 6.6.x.
@echo.

@%GEMSTONE%\bin\waitstone %stoneName% -1 >nul:
@if not errorlevel 1 goto waitstoneok
  @echo ERROR: stone named %stoneName% is not running.
  @goto failed
:waitstoneok
  
@echo.
@echo Beginning upgrade.
@%GEMSTONE%\bin\topaz -i -l < %upgradeDir%\upgradeImage.topaz > %upgradeLogDir%\topaz.out

@if not errorlevel 3 goto step1ok
  @echo ERROR: topaz exited with an error.
  @findstr /l /c:"ERROR:" %upgradeLogDir%\upgradeImage.out %upgradeLogDir%\filein1.out %upgradeLogDir%\filein2.out %upgradeLogDir%\bomlast.out %upgradeLogDir%\version.out %upgradeLogDir%\clusterimage.out
  @goto failed

:step1ok
@echo.
@echo Upgrade is now complete.

:failed
@endlocal
