!=========================================================================
! Copyright (C) VMware, Inc. 1986-2011.  All Rights Reserved.
!
! $Id: constrpathterm.gs,v 1.7 2008-01-09 19:02:31 stever Exp $
!
! Superclass Hierarchy:
!   ConstrainedPathTerm, PathTerm, Array, SequenceableCollection, Collection,
!   Object.
!
!=========================================================================

! class created in idxclasses.topaz

removeallmethods ConstrainedPathTerm
removeallclassmethods ConstrainedPathTerm
protectmethods

category: 'For Documentation Installation only'
classmethod: ConstrainedPathTerm
installDocumentation

< unprotected >

| doc |
doc := GsClassDocumentation _newForPrivateGsClass: self.

doc documentClassWith: (GsDocText new).

self description: doc.
%

! ------------------- Instance methods for ConstrainedPathTerm
category: 'Accessing'
method: ConstrainedPathTerm
_ivOffsetFor: anObject

"Returns the instance variable offset of anObject for the instance variable
 corresponding to the receiver path term."
<protected>

| sc |
" must make sure that anObject is the right class "
anObject class == constraintClass
    ifTrue: [ ^ ivOffset ].

" check superclasses "
sc := anObject class superclass.
[ nil ~~ sc ] whileTrue: [
    sc == constraintClass
        ifTrue: [ ^ ivOffset ].
    sc := sc superclass
].

^ super _ivOffsetFor: anObject
%

category: 'Accessing'
method: ConstrainedPathTerm
constraintClass

"Returns the value of the instance variable 'constraintClass'."
<protected>

^constraintClass
%

category: 'Updating'
method: ConstrainedPathTerm
constraintClass: newValue

"Modifies the value of the instance variable 'constraintClass'."
<protected>

constraintClass := newValue
%

category: 'Accessing'
method: ConstrainedPathTerm
ivOffset

"Returns the value of the instance variable 'ivOffset'."
<protected>

^ivOffset
%

category: 'Updating'
method: ConstrainedPathTerm
ivOffset: newValue

"Modifies the value of the instance variable 'ivOffset'."
<protected>

ivOffset := newValue
%

category: 'Testing'
method: ConstrainedPathTerm
isConstrained

"Returns true if all children of the receiver are constrained."
<protected>

1 to: children size do: [ :i |
    (children at: i) isConstrained
        ifFalse: [ ^ false ]
].
^ true
%

category: 'Testing'
method: ConstrainedPathTerm
_checkBtreeComparisonWith: anObject

"Returns whether the receiver's B-tree can hold an entry with anObject as the
 key.  Since the path is constrained, this is always true."
<unprotected>

^ true
%

category: 'Testing'
method: ConstrainedPathTerm
isPathConstrained

"Returns true if the path represented by the receiver is fully constrained."
<unprotected>

^ true
%

category: 'Updating Indexes'
method: ConstrainedPathTerm
_clear
<protected>

"Assigns nil to important instance variables and sets the receiver's size
 to zero."

super _clear.
constraintClass := nil.
%

unprotectmethods

